=== libs/interprocess/CMakeLists.txt ===
# Generated by `boostdep --cmake interprocess`
# Copyright 2020 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_interprocess VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_interprocess INTERFACE)
add_library(Boost::interprocess ALIAS boost_interprocess)

target_include_directories(boost_interprocess INTERFACE include)

target_link_libraries(boost_interprocess
  INTERFACE
    Boost::assert
    Boost::config
    Boost::container
    Boost::intrusive
    Boost::move
    Boost::winapi
)

if(CMAKE_VERSION VERSION_GREATER 3.18 AND CMAKE_GENERATOR MATCHES "Visual Studio")

  file(GLOB_RECURSE boost_interprocess_IDEFILES CONFIGURE_DEPENDS include/*.hpp)
  source_group(TREE ${PROJECT_SOURCE_DIR}/include FILES ${boost_interprocess_IDEFILES} PREFIX "Header Files")
  list(APPEND boost_interprocess_IDEFILES extra/boost_interprocess.natvis)
  target_sources(boost_interprocess PRIVATE ${boost_interprocess_IDEFILES})

endif()

if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
    target_link_libraries(boost_interprocess INTERFACE rt)
elseif (CMAKE_SYSTEM_NAME STREQUAL "Windows")
    target_link_libraries(boost_interprocess INTERFACE ole32 oleaut32 psapi advapi32)
endif()

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()
